<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "organization_import_log".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "OrganizationImportLog".
 *
 * Columns in table "organization_import_log" available as properties of the model,
 * followed by relations of table "organization_import_log" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property integer $provider_id
 * @property integer $external_provider_id
 * @property integer $practice_id
 * @property integer $external_practice_id
 * @property integer $practice_group_id
 * @property integer $external_practice_group_id
 * @property string $npi_id
 * @property string $date_added
 * @property string $last_modified_date
 * @property string $source_url
 * @property string $source_data
 *
 * @property Organization $organization
 * @property Provider $provider
 * @property Practice $practice
 */
abstract class BaseOrganizationImportLog extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'organization_import_log';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'OrganizationImportLog|OrganizationImportLogs', $n);
    }

    public static function representingColumn()
    {
        return 'source_url';
    }

    public function rules()
    {
        return array(
            array('source_url', 'required'),
            array('organization_id, provider_id, external_provider_id, practice_id, external_practice_id, practice_group_id, external_practice_group_id', 'numerical', 'integerOnly' => true),
            array('npi_id', 'length', 'max' => 10),
            array('source_url', 'length', 'max' => 255),
            array('date_added, last_modified_date, source_data', 'safe'),
            array('organization_id, provider_id, external_provider_id, practice_id, external_practice_id, practice_group_id, external_practice_group_id, npi_id, date_added, last_modified_date, source_data', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, provider_id, external_provider_id, practice_id, external_practice_id, practice_group_id, external_practice_group_id, npi_id, date_added, last_modified_date, source_url, source_data', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => null,
            'provider_id' => null,
            'external_provider_id' => Yii::t('app', 'External Provider'),
            'practice_id' => null,
            'external_practice_id' => Yii::t('app', 'External Practice'),
            'practice_group_id' => null,
            'external_practice_group_id' => Yii::t('app', 'External Practice'),
            'npi_id' => Yii::t('app', 'Npi'),
            'date_added' => Yii::t('app', 'Date Added'),
            'last_modified_date' => Yii::t('app', 'Last Modified Date'),
            'source_url' => Yii::t('app', 'Source Url'),
            'source_data' => Yii::t('app', 'Source Data'),
            'organization' => null,
            'provider' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('external_provider_id', $this->external_provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('external_practice_id', $this->external_practice_id);
        $criteria->compare('practice_group_id', $this->external_practice_id);
        $criteria->compare('external_practice_group_id', $this->external_practice_id);
        $criteria->compare('npi_id', $this->npi_id, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('last_modified_date', $this->last_modified_date, true);
        $criteria->compare('source_url', $this->source_url, true);
        $criteria->compare('source_data', $this->source_data, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
